// Wait.cpp : Defines the initialization routines for the DLL.
//

#include "stdafx.h"
#include <afxdllx.h>
#include "wait.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

typedef struct
{
	CString strPathName;
	CEvent * pTermThreadEvent;
} THREADINFO, *FAR LPTHREADINFO;
UINT LaunchAndWait(LPVOID pParam);
BOOL LaunchApplication(LPCTSTR pCmdLine, PROCESS_INFORMATION *pProcessInfo);

static AFX_EXTENSION_MODULE WaitDLL = { NULL, NULL };
_declspec(dllexport) BOOL Wait(CString szCmdLine)
{
	LPTHREADINFO pThreadInfo = new THREADINFO;
	CEvent *pThreadEvent = new CEvent(FALSE, TRUE); 
	ASSERT_VALID(pThreadEvent);
	if(pThreadInfo)
	{
		pThreadInfo->pTermThreadEvent = pThreadEvent;
		pThreadInfo->strPathName = szCmdLine;

		AfxBeginThread(LaunchAndWait, pThreadInfo);
		WaitForSingleObject(pThreadEvent->m_hObject, INFINITE);
		return TRUE;
	}
	return FALSE;
}

extern "C" int APIENTRY
DllMain(HINSTANCE hInstance, DWORD dwReason, LPVOID lpReserved)
{
	// Remove this if you use lpReserved
	UNREFERENCED_PARAMETER(lpReserved);

	if (dwReason == DLL_PROCESS_ATTACH)
	{
		TRACE0("WAIT.DLL Initializing!\n");
		
		// Extension DLL one-time initialization
		if (!AfxInitExtensionModule(WaitDLL, hInstance))
			return 0;

		// Insert this DLL into the resource chain
		// NOTE: If this Extension DLL is being implicitly linked to by
		//  an MFC Regular DLL (such as an ActiveX Control)
		//  instead of an MFC application, then you will want to
		//  remove this line from DllMain and put it in a separate
		//  function exported from this Extension DLL.  The Regular DLL
		//  that uses this Extension DLL should then explicitly call that
		//  function to initialize this Extension DLL.  Otherwise,
		//  the CDynLinkLibrary object will not be attached to the
		//  Regular DLL's resource chain, and serious problems will
		//  result.

		new CDynLinkLibrary(WaitDLL);
	}
	else if (dwReason == DLL_PROCESS_DETACH)
	{
		TRACE0("WAIT.DLL Terminating!\n");
		// Terminate the library before destructors are called
		AfxTermExtensionModule(WaitDLL);
	}
	return 1;   // ok
}


UINT LaunchAndWait(LPVOID pParam)
{
	LPTHREADINFO pThreadInfo = (LPTHREADINFO) pParam;
	PROCESS_INFORMATION stProcessInfo;
	if(LaunchApplication(pThreadInfo->strPathName, &stProcessInfo))
	{
		HANDLE hThreads[2];
		hThreads[0] = pThreadInfo->pTermThreadEvent->m_hObject;
		hThreads[1] = stProcessInfo.hProcess;
		DWORD dwIndex = WaitForMultipleObjects(2, hThreads, FALSE, INFINITE);
		CloseHandle(stProcessInfo.hThread);
		CloseHandle(stProcessInfo.hProcess);
		pThreadInfo->pTermThreadEvent->SetEvent();
		if(pThreadInfo)
			delete pThreadInfo;
	}
	else
		pThreadInfo->pTermThreadEvent->SetEvent();
	return 0;
}

BOOL LaunchApplication(LPCTSTR pCmdLine, PROCESS_INFORMATION *pProcessInfo)
{
	STARTUPINFO stStartUpInfo;

	memset(&stStartUpInfo, 0, sizeof(STARTUPINFO));

	stStartUpInfo.cb = sizeof(STARTUPINFO);

	stStartUpInfo.dwFlags = STARTF_USESHOWWINDOW;
	stStartUpInfo.wShowWindow = SW_SHOWDEFAULT;

	return CreateProcess(NULL, (LPTSTR)pCmdLine, NULL, NULL, FALSE,
		NORMAL_PRIORITY_CLASS, NULL, 
		NULL, &stStartUpInfo, pProcessInfo);
}

